; ----------------------------------------------------------------------------
; -       TITULO  : Ejemplo de botones en Windows W-FASM                     -
; -----                                                                  -----
; -       AUTOR   : Alfonso Vctor Caballero Hurtado                         -
; -----                                                                  -----
; -       VERSION : 1.0                                                      -
; -----                                                                  -----
; -      (c) 2010. Abre los Ojos al Ensamblador                              -
; ----------------------------------------------------------------------------

; Todas las palabras reservadas deben estar en minsculas

format PE GUI 4.0
entry start

include 'win32a.inc'         ; Inclumos definiciones de estructuras y constantes

cdXPos           EQU  128     ; Constante double X-Posicin de la ventana(esq sup izqda)
cdYPos           EQU  128     ; Constante double Y-Posicin de la ventana(esq sup izqda)
cdXSize          EQU  320     ; Constante double X-tamao de la ventana
cdYSize          EQU  240     ; Constante double Y-tamao de la ventana
cdColFondo       EQU  COLOR_BTNFACE + 1  ; Color de fondo de la ventana: gris de un botn de comando
cdVIcono         EQU  IDI_APPLICATION ; Icono de la ventana, vase Resource.H
cdVCursor        EQU  IDC_ARROW   ; Cursor para la ventana

cdVBarTipo       EQU  NULL                 ; Normal, con icono
cdVBtnTipo       EQU  WS_GROUP+WS_SYSMENU+WS_VISIBLE ; Todos los botones visibles, slo activos minimizar y cerrar
cdID_OBJETO      EQU  500
cdObjX1          EQU  10
cdObjY1          EQU  20
cdObjX2          EQU  145
cdObjY2          EQU  100
cdObjX3          EQU  10
cdObjY3          EQU  20
cdObjX4          EQU  10
cdObjY4          EQU  60
FLOODFILLSURFACE equ  1
; Constantes del resource
cdMAIN_ICON      EQU  100        ; Icono de la aplicacin
cdWINDOW_ICON    EQU  101        ; Icono de la ventana principal
cdINFO_ICON      EQU  102
cdEXIT_U_ICON    EQU  103
cdEXIT_D_ICON    EQU  104
cdJUDGE_ICON     EQU  105
cdPOLIT_U_BMP    EQU  200
cdPOLIT_D_BMP    EQU  201
cdPOLIT_P_BMP    EQU  202
cdJUDGE_BMP      EQU  203
cdBOX_GLOBE_CUR  EQU  204
cdIDC_BUTTON     EQU  3000
cdIDC_UDC1       equ  1003
cdIDC_EDT1       equ  1002
cdIDC_STC7       equ  1008
cdIDC_STC8       equ  1009
ABOUTCOLOR       equ  00FF8080h
cdIdDialogo      EQU  37    ; El Id de la ventana modal (dialogo)
; Hyperlink constants
HLM_SETTYPE      EQU  WM_USER+200     ; lParam = HLINK_URL/HLINK_EMAIL wndxtra 0
HLM_SETHOTCOLOR  EQU  WM_USER+201     ; lParam = Hot color wndxtra 4
HLM_SETTEXTCOLOR EQU  WM_USER+202     ; lParam = Normal text color wndxtra 8
HLM_SETSUBJECT   EQU  WM_USER+203     ; lParam = Email subject line wndxtra 24
HLM_SETBODY      EQU  WM_USER+204     ; lParam = Email body wndxtra 28
HLM_SETUNDERLINE EQU  WM_USER+205     ; lParam = Underline link TRUE/FALSE wndxtra 32
HLM_SETLINK      EQU  WM_USER+206     ; lParam = Hyperlink URL wndxtra 36
HLINK_URL        EQU  0
HLINK_EMAIL      EQU  1
; Otros
GMEM_FIXED       EQU  0h
GMEM_ZEROINIT    EQU  40h
GPTR             EQU  GMEM_FIXED + GMEM_ZEROINIT
TME_LEAVE        EQU  2
COLOR_3DFACE     EQU  COLOR_BTNFACE
HOVER_DEFAULT    EQU  0FFFFFFFFh
ID_STATIC        EQU  -1

struc DatosControl   dcClase,dcTexto,dcEstilo,dcPosX,dcPosY,dcAncho,dcAlto,dcIdObjeto,dcHandle
{
  .dcClase     DD  dcClase
  .dcTexto     DD  dcTexto   
  .dcEstilo    DD  dcEstilo  
  .dcPosX      DD  dcPosX    
  .dcPosY      DD  dcPosY    
  .dcAncho     DD  dcAncho   
  .dcAlto      DD  dcAlto    
  .dcIdObjeto  DD  dcIdObjeto
  .dcHandle    DD  dcHandle  
}
DatosControl_size  EQU  9*4

struct TRACKMOUSEEVENT
  cbSize       dd ?
  dwFlags      dd ?
  hwndTrack    dd ?
  dwHoverTime  dd ?
ends

TRACKMOUSEEVENT_size equ 4*4
WNDCLASSEX_size      equ 4*12

section '.text' code readable executable
  start:
    invoke    GetModuleHandle,0
    mov       [wc.hInstance],eax
    invoke    GetCommandLine
    mov       [CommandLine], EAX
    stdcall   InitHyperLinkClass
    invoke    CreateFontIndirect, Arial_Black_10
    mov       [hFont10], eax
    invoke    InitCommonControls
    stdcall   WinMain, [wc.hInstance], NULL, [CommandLine], SW_SHOWDEFAULT
    invoke    DeleteObject, [hFont10]
    invoke    ExitProcess,[msg.wParam]

proc WinMain uses ebx esi edi, hInst, hPrevInst, CmdLine, CmdShow
    ;  Propsito: Inicializamos la ventana principal de la aplicacin y captura errores, si los hubiere
    ;  Entrada  : hInst, hPrevInst, CmdLine, CmdShow
    ;  Salida   : Ninguna
    ;  Destruye : Ninguna
    invoke    LoadIcon,[hInst],cdWINDOW_ICON
    mov       [wc.hIcon],eax
    invoke    LoadCursor,0,cdVCursor
    mov       [wc.hCursor],eax
    invoke    RegisterClass,wc
    test      eax,eax
    jz        error

    invoke    CreateWindowEx,cdVBarTipo,NombreClase,MsgCabecera,\
              cdVBtnTipo,cdXPos, cdYPos, cdXSize, cdYSize,\
              NULL,NULL,[wc.hInstance],NULL
    test      eax,eax
    jz        error

    msg_loop:
      invoke    GetMessage,msg,NULL,0,0
      cmp       eax,1
      jb        end_loop
      jne       msg_loop
      invoke    TranslateMessage,msg
      invoke    DispatchMessage,msg
    jmp       msg_loop

  error:
    invoke    MessageBox,NULL,MsgError,NULL,MB_ICONERROR+MB_OK

  end_loop:
    MOV       EAX, [msg.wParam]
    ret
endp

proc WndProc uses ebx esi edi, hwnd,wmsg,wparam,lparam
    ;  Propsito: Procesa los mensajes provenientes de las ventanas
    ;  Entrada  : hwnd,wmsg,wparam,lparam
    ;  Salida   : Ninguna
    ;  Destruye : Ninguna
    ;  Si usramos WM_PAINT, al menos aqu habra que redireccionar a wmDefault para que funcione

    mov       eax, [wmsg]
    cmp       eax, WM_DESTROY
    jz        wmDestroy
    cmp       eax, WM_COMMAND
    jz        wmCommand
    cmp       eax, WM_CREATE
    jz        wmCreate

    wmDefault:
      invoke   DefWindowProcA, [hwnd], [wmsg], [wparam], [lparam]
      jmp      wmFin
    wmCreate:
      mov      eax, [hwnd]
      mov      [wHandle], eax
      stdcall  CreaObjetos, [hwnd]
      jmp      wmFin
    wmCommand:
      MOV      EAX, [wparam]
      CMP      EAX, [btnMensaje.dcIdObjeto]
      JNE      wmDefault
        invoke    MessageBox,[hwnd],  Credit, MsgCabecera,MB_OK+MB_ICONASTERISK
      JMP      wmFin
    wmDestroy:
      invoke   PostQuitMessage,0
    wmFin:
    ret
endp

proc  CreaObjetos uses ecx esi, uWnd
  ;  Propsito: Crea los objetos en la ventana
  ;  Entrada  : Ninguna
  ;  Salida   : Ninguna
  ;  Destruye : Ninguna
  ; Creamos los contenedores
  mov       esi, 0
  mov       ecx, 2           ; Contador de objetos
  L_Crea_Objetos_Agrupadores:
    push      ecx
    push      esi
    invoke    CreateWindowEx, NULL,\
              ClaseBoton,\
              [esi+gpbBmp.dcTexto],\
              [esi+gpbBmp.dcEstilo],\
              [esi+gpbBmp.dcPosX],\
              [esi+gpbBmp.dcPosY],\
              [esi+gpbBmp.dcAncho],\
              [esi+gpbBmp.dcAlto],\
              [uWnd],[esi+gpbBmp.dcIdObjeto], [wc.hInstance], 0
    mov       [esi+gpbBmp.dcHandle], eax      ; Guardamos su manejador
    pop       esi
    pop       ecx
    add       esi, DatosControl_size
  loop     L_Crea_Objetos_Agrupadores
  ; Creamos los botones del agrupador bmp
  mov      esi, 0             ; Puntero donde empieza a mirar
  mov      ecx, 2             ; Contador de objetos
  L_Crea_Objetos_But_BMP:
    push     ecx
    push     esi
    invoke   CreateWindowExA, NULL,\
             ClaseBoton,\
             [esi+btnPolit.dcTexto],\
             [esi+btnPolit.dcEstilo],\
             [esi+btnPolit.dcPosX],\
             [esi+btnPolit.dcPosY],\
             [esi+btnPolit.dcAncho],\
             [esi+btnPolit.dcAlto],\
             [gpbBmp.dcHandle], [esi+btnPolit.dcIdObjeto], [wc.hInstance], NULL
    mov      [esi+btnPolit.dcHandle], eax      ; Guardamos su manejador
    pop      esi
    pop      ecx
    add      esi, DatosControl_size
  loop     L_Crea_Objetos_But_BMP
  ; Creamos los textos del agrupador bmp
  mov      esi, 0               ; Puntero donde empieza a mirar
  mov      ecx, 2               ; Contador de objetos
  L_Crea_Objetos_Txt_BMP:
    push     ecx
    push     esi
    invoke   CreateWindowExA, NULL,\
             ClaseTexto,\
             [esi+txtPolit.dcTexto],\
             [esi+txtPolit.dcEstilo],\
             [esi+txtPolit.dcPosX],\
             [esi+txtPolit.dcPosY],\
             [esi+txtPolit.dcAncho],\
             [esi+txtPolit.dcAlto],\
             [gpbBmp.dcHandle], [esi+txtPolit.dcIdObjeto], [wc.hInstance], NULL
    mov      [esi+txtPolit.dcHandle], eax      ; Guardamos su manejador
    pop      esi
    pop      ecx
    add      esi, DatosControl_size
  loop     L_Crea_Objetos_Txt_BMP
  ; Creamos los botones del agrupador ico
  mov      esi, 0             ; Puntero donde empieza a mirar
  mov      ecx, 2             ; Contador de objetos
  L_Crea_Objetos_But_ICO:
    push     ecx
    push     esi
    invoke   CreateWindowExA, NULL,\
             ClaseBoton,\
             [esi+btnInfo.dcTexto],\
             [esi+btnInfo.dcEstilo],\
             [esi+btnInfo.dcPosX],\
             [esi+btnInfo.dcPosY],\
             [esi+btnInfo.dcAncho],\
             [esi+btnInfo.dcAlto],\
             [gpbIco.dcHandle], [esi+btnInfo.dcIdObjeto], [wc.hInstance], NULL
    mov      [esi+btnInfo.dcHandle], eax      ; Guardamos su manejador
    pop      esi
    pop      ecx
    add      esi, DatosControl_size
  loop     L_Crea_Objetos_But_ICO
  ; El boton
    invoke    CreateWindowExA, NULL,\
                  ClaseBoton,\
                  [btnMensaje.dcTexto],\
                  [btnMensaje.dcEstilo],\
                  [btnMensaje.dcPosX],\
                  [btnMensaje.dcPosY],\
                  [btnMensaje.dcAncho],\
                  [btnMensaje.dcAlto],\
                  [uWnd],[btnMensaje.dcIdObjeto], [wc.hInstance], NULL
    mov       [btnMensaje.dcHandle], eax          ; Guardamos su manejador
  ; Recogemos los grficos
  invoke   LoadCursor, [wc.hInstance], cdBOX_GLOBE_CUR
  mov      [hCursor], eax
  invoke   LoadIcon,[wc.hInstance],cdINFO_ICON
  mov      [hIcoInfo], eax
  invoke   LoadIcon,[wc.hInstance],cdEXIT_U_ICON
  mov      [hIcoUExit], eax
  invoke   LoadIcon,[wc.hInstance],cdEXIT_D_ICON
  mov      [hIcoDExit], eax
  invoke   LoadBitmap,[wc.hInstance],cdPOLIT_U_BMP
  mov      [hBmpUPolit], eax
  invoke   LoadBitmap,[wc.hInstance],cdPOLIT_D_BMP
  mov      [hBmpDPolit], eax
  invoke   LoadBitmap,[wc.hInstance],cdPOLIT_P_BMP
  mov      [hBmpPPolit], eax
  invoke   LoadBitmap,[wc.hInstance],cdJUDGE_BMP
  mov      [hBmpJudge], eax
  ; Establecemos el color de los bmp (cuidado aqu)
  stdcall  SetBmpColor,[hBmpUPolit]
  mov      [hBmpUPolit],eax
  stdcall  SetBmpColor,[hBmpDPolit]
  mov      [hBmpDPolit],eax
  stdcall  SetBmpColor,[hBmpJudge]
  mov      [hBmpJudge],eax
  ; Pintamos las imgenes en los botones
  invoke   SendMessage,[btnPolit.dcHandle],BM_SETIMAGE,0,[hBmpUPolit]     ; BMP
  invoke   SendMessage,[btnJudge.dcHandle],BM_SETIMAGE,eax,[hBmpJudge]   ; BMP
  invoke   SendMessage,[btnInfo.dcHandle],BM_SETIMAGE,1,[hIcoInfo]      ; Icono
  invoke   SendMessage,[btnExit.dcHandle],BM_SETIMAGE,1,[hIcoUExit]      ; Icono
  ; Creamos los botones con doble imagen
  invoke   SetWindowLong,[gpbBmp.dcHandle],GWL_WNDPROC,WndBmpProc               ; BMP politico
  mov      [lpfnbmpProcBmp], eax
  invoke   SetWindowLong,[gpbIco.dcHandle],GWL_WNDPROC,WndIcoProc               ; Icono salir
  mov      [lpBtnProcIco], eax
  invoke   SetWindowLong,[btnPolit.dcHandle],GWL_WNDPROC,WndBmpProc               ; BMP politico
  mov      [lpfnbmpProc], eax
  invoke   SetWindowLong,[btnExit.dcHandle],GWL_WNDPROC,WndIcoProc               ; Icono salir
  mov      [lpBtnProc], eax
  ret
endp

SetBmpColor:  ; hBitmap
  ;  Propsito: Modifica el color de relleno a color tipo botn
  ;  Entrada  : Ninguna
  ;  Salida   : Ninguna
  ;  Destruye : Ninguna
  ;   LOCAL    mDC:DWORD, hBrush:DWORD, hOldBmp:DWORD, hReturn:DWORD, hOldBrush:DWORD
  ; mDC:ebp-4*5, hBrush:ebp-4*4, hOldBmp:ebp-4*3, hReturn:ebp-4*2, hOldBrush:ebp-4*1
  ; hBitmap:ebp+4*2 (en la pila tenemos [ebp][eip][hBitmap])
    ; Antes de usar un DC para operaciones de dibujo, se debe insertado en el DC un bitmap
    ; con la anchura y altura correctas. Entonces se podr usar para preparar imgenes que sern
    ; copiadas en la pantalla o imprimidas. Cuando ya no se use ms, se borrar con DeleteDC.
  push     ebp
  mov      ebp, esp
  sub      esp, 4*6                          ; Hacemos sitio para las 5 variables locales
  invoke   CreateCompatibleDC,NULL           ; Crea una memoria de contexto de dispositivo compatible con el dispositivo especificado
  mov      [ebp-4*5],eax
  invoke   SelectObject,[ebp-4*5],[ebp+4*2]  ; Seleccionamos el objeto hBitmap en el mDC
  mov      [ebp-4*3],eax
  invoke   GetSysColor,COLOR_BTNFACE         ; Recupera el color actual del elemento (color botn)
  invoke   CreateSolidBrush,eax              ; Crea un pincel lgico con el especificado color slido
  mov      [ebp-4*4],eax
  invoke   SelectObject,[ebp-4*5],[ebp-4*4]  ; Seleccionamos el objeto hBrush en el mDC
  mov      [ebp-4*2],eax
  invoke   GetPixel,[ebp-4*5],1,1            ; Recupera el RGB-valor de la coordenada 1,1 en mDC
  invoke   ExtFloodFill,[ebp-4*5],1,1,eax,FLOODFILLSURFACE  ; Modifica el color obtenido atrs por el del hBrush
  invoke   SelectObject,[ebp-4*5],[ebp-4*2] ; Seleccionamos el objeto hOldBrush en el mDC
  invoke   DeleteObject,[ebp-4*4]           ; Borramos el pincel lgico
  invoke   SelectObject,[ebp-4*5],[ebp+4*2] ; Seleccionamos el objeto hBitmap en el mDC
  push     eax
  invoke   DeleteDC,[ebp-4*5]               ; Borramos el mDC
  pop      eax
  mov      esp, ebp
  pop      ebp
ret      4*1     ; 1 parmetro


proc WndInfoProc hWnd,iMsg,wParam, lParam
  ;  Propsito: Este es el WndProc para la ventana modal de informacin
  ;  Entrada  : Ninguna
  ;  Salida   : Ninguna
  ;  Destruye : Ninguna
  mov       eax, [iMsg]
  cmp       eax, WM_INITDIALOG
  jz        .wmInitDialog
  cmp       eax, WM_CLOSE
  jz        .wmClose
  cmp       eax, WM_COMMAND
  jz        .wmCommand

  .wmDefault:
      MOV   EAX,FALSE
      ret
  .wmInitDialog:
      invoke    GetDlgItem,[hWnd],cdIDC_BUTTON
      invoke    SetFocus,EAX
      ; Modificamos las propiedades del cuadro de texto
      invoke    SetDlgItemText, [hWnd], cdIDC_EDT1, [lParam]
      ; invoke    SetWindowText,[txtJudge.dcHandle], MsgTxtJudge1   ; avch, obsrvese la diferencia entre los dos
      ; Mandamos mensaje al control especificado en un cuadro de dilogo
      invoke    SendDlgItemMessage, [hWnd], cdIDC_UDC1, WM_SETTEXT, 0, WebSiteDisplay
      invoke    SendDlgItemMessage, [hWnd], cdIDC_UDC1, HLM_SETLINK, 0, WebSite
      invoke    SendDlgItemMessage, [hWnd], cdIDC_UDC1, HLM_SETHOTCOLOR, 0, 0FF0000h
      invoke    SendDlgItemMessage, [hWnd], cdIDC_UDC1, HLM_SETTEXTCOLOR, 0, 0
      invoke    SendDlgItemMessage, [hWnd], cdIDC_UDC1, HLM_SETTYPE, 0, HLINK_URL
      invoke    SendDlgItemMessage, [hWnd], cdIDC_UDC1, HLM_SETUNDERLINE, 0, TRUE
      jmp       .wmFin
  .wmClose:
      invoke    EndDialog,[hWnd],NULL
      jmp       .wmFin
  .wmCommand:
      MOV       EAX,[wParam]
      MOV       EDX,EAX
      SHR       EDX,16
      CMP       DX, BN_CLICKED
      JNZ       .wmFin
      CMP       EAX, cdIDC_BUTTON
      JNZ       .wmFin
        invoke    SendMessageA,[hWnd],WM_CLOSE,NULL,NULL
  .wmFin:
  MOV  EAX,TRUE
  ret
endp

proc WndIcoProc   hCtl, uMsg, wParam, lParam
  ;  Propsito: Este es el WndProc para los botones de los iconos
  ;  Entrada  : Ninguna
  ;  Salida   : Ninguna
  ;  Destruye : Ninguna
   mov     eax, [uMsg]
   cmp     eax, WM_KEYDOWN
   jz      .wmKeyDown
   cmp     eax, WM_KEYUP
   jz      .wmKeyUp
   cmp     eax, WM_LBUTTONDOWN
   jz      .wmLButtonDown
   cmp     eax, WM_LBUTTONUP
   jz      .wmLButtonUp
   cmp     eax, WM_COMMAND
   jz      .wmCommand
   jmp     .wmFin

  .wmKeyDown:
      jmp      .wmLButtonDown
  .wmKeyUp:
      jmp      .wmLButtonUp
  .wmLButtonDown:
      invoke   SendMessage,[btnExit.dcHandle],BM_SETIMAGE,1,[hIcoDExit]
      jmp      .wmFin
  .wmLButtonUp:
      invoke   SendMessage,[btnExit.dcHandle],BM_SETIMAGE,1,[hIcoUExit]
      jmp      .wmFin
  .wmCommand:
      mov      eax, [wParam]
      cmp      eax, [btnInfo.dcIdObjeto]
      jz       .btnInfo
      cmp      eax, [btnExit.dcIdObjeto]
      jz       .btnExit
      jmp      .wmFin
      .btnInfo:
        invoke   DialogBoxParam,[wc.hInstance], cdIdDialogo,[gpbIco.dcHandle],WndInfoProc,AboutText
        jmp      .wmFin
      .btnExit:
        invoke   PostQuitMessage, NULL
  .wmFin:
  invoke   CallWindowProc,[lpBtnProc],[hCtl],[uMsg],[wParam],[lParam]
  ret
endp

proc WndBmpProc    hCtl, uMsg, wParam, lParam
  ;  Propsito: Este es el WndProc para los botones de los bitmaps
  ;  Entrada  : Ninguna
  ;  Salida   : Ninguna
  ;  Destruye : Ninguna
   mov     eax, [uMsg]
   cmp     eax, WM_KEYDOWN
   jz      .wmKeyDown
   cmp     eax, WM_KEYUP
   jz      .wmKeyUp
   cmp     eax, WM_MOUSEMOVE
   jz      .wmMouseMove
   cmp     eax, WM_ENABLE
   jz      .wmEnable
   cmp     eax, WM_LBUTTONDOWN
   jz      .wmLButtonDown
   cmp     eax, WM_LBUTTONUP
   jz      .wmLButtonUp
   cmp     eax, WM_COMMAND
   jz      .wmCommand
   jmp     .wmFin

  .wmKeyDown:
      jmp      .wmLButtonDown
  .wmKeyUp:
      jmp      .wmLButtonUp
  .wmMouseMove:
      invoke   SetCursor, [hCursor]
      jmp      .wmFin
  .wmEnable:      ; Aqu entra cuando se activa/desactiva el botn del poltico
      cmp      [vbButActiv], 0      ; Si no est activo, se carga la imagen protegida
      jnz      .btnActivo
        invoke   SendMessage,[btnPolit.dcHandle],BM_SETIMAGE,0,[hBmpPPolit]
        jmp      .btnFin
      .btnActivo:
        invoke   SendMessage,[btnPolit.dcHandle],BM_SETIMAGE,0,[hBmpUPolit]
      .btnFin:
      jmp      .wmFin
  .wmLButtonDown:
      invoke   SetCursor, [hCursor]
      invoke   SendMessage,[btnPolit.dcHandle],BM_SETIMAGE,0,[hBmpDPolit]
      jmp      .wmFin
  .wmLButtonUp:
      invoke   SendMessage,[btnPolit.dcHandle],BM_SETIMAGE,0,[hBmpUPolit]
      jmp      .wmFin
  .wmCommand:
      mov      eax, [wParam]
      cmp      eax, [btnJudge.dcIdObjeto]
      jz       .btnJudge
      cmp      eax, [btnPolit.dcIdObjeto]
      jz       .btnPolit
      jmp      .wmFin

      .btnJudge:
        cmp       [vbButActiv], 0
        jz        .btnDesActivo
          MOV       [vbButActiv], 0          ; Ahora est desactivado
          invoke    EnableWindow, [btnPolit.dcHandle], FALSE
          stdcall   MessageBoxSTD,[gpbBmp.dcHandle],MsgBmpJudgeTxt1,MsgBmpJudgeCab,MB_OK,cdJUDGE_ICON
          invoke    SetWindowText,[txtJudge.dcHandle],MsgTxtJudge2
          jmp       .btnFin2
        .btnDesActivo:             ; Si no est activo
          MOV       [vbButActiv], 1        ; Ahora est activo
          invoke    EnableWindow, [btnPolit.dcHandle], TRUE
          stdcall   MessageBoxSTD,[gpbBmp.dcHandle], MsgBmpJudgeTxt2, MsgBmpJudgeCab,MB_OK,cdJUDGE_ICON
          invoke    SetWindowText,[txtJudge.dcHandle], MsgTxtJudge1
        .btnFin2:
        jmp      .wmFin
      .btnPolit:
        invoke    MessageBox,NULL, MsgBmpPolitTxt, MsgBmpPolitCab,MB_OK
  .wmFin:
  invoke   CallWindowProc,[lpfnbmpProc],[hCtl],[uMsg],[wParam],[lParam]
  ret
endp

proc  MessageBoxSTD hParent, lpMsg,lpTitle,dlgStyle,iconID
  ;  Propsito: Crea un MessageBox modal
  ;  Entrada  : Ninguna
  ;  Salida   : Ninguna
  ;  Destruye : Ninguna
  mov       [mbp1+MSGBOXPARAMS.cbSize], 10*4;MSGBOXPARAMS_size
  mov       eax, [hParent]
  mov       [mbp1+MSGBOXPARAMS.hwndOwner], eax
  mov       eax, [wc.hInstance]
  mov       [mbp1+MSGBOXPARAMS.hInstance], eax
  mov       eax, [lpMsg]
  mov       [mbp1+MSGBOXPARAMS.lpszText], eax
  mov       eax, [lpTitle]
  mov       [mbp1+MSGBOXPARAMS.lpszCaption], eax
  mov       eax, [dlgStyle]
  or        eax, MB_USERICON
  mov       [mbp1+MSGBOXPARAMS.dwStyle], eax
  mov       eax, [iconID]
  mov       [mbp1+MSGBOXPARAMS.lpszIcon], eax
  mov       [mbp1+MSGBOXPARAMS.dwContextHelpId], NULL
  mov       [mbp1+MSGBOXPARAMS.lpfnMsgBoxCallback], NULL
  mov       [mbp1+MSGBOXPARAMS.dwLanguageId], NULL
  invoke    MessageBoxIndirectA, mbp1
  ret
endp

proc _Hyperlink hlc_hWin, hlc_uMsg, hlc_wParam, hlc_lParam
  ;  Propsito: Este es el gestor del hiperlink, definiendo todas las ocurrencias
  ;             que pueden darse cuando se trabaja con l. El cdigo pertenece a Donkey Stable
  ;             (Edgar Hansen) ligeramente modificado por m
  ;  Entrada  : hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
  ;  Salida   : Ninguna
  ;  Destruye : EAX, ECX
;  LOCAL hlc_tme:TRACKMOUSEEVENT, hlc_ps:PAINTSTRUCT, hlc_hdc:DWORD
;  LOCAL hlc_strlen:DWORD, hlc_prc:RECT, hlc_color:DWORD
;  LOCAL hlc_pt:POINT, hlc_text[2048]:BYTE, hlc_pSubject:DWORD
  MOV     EAX, [hlc_uMsg]
  CMP     EAX, WM_SETTEXT
  JE      .wmSETTEXT
  CMP     EAX, WM_CREATE
  JE      .wmCREATE
  CMP     EAX, HLM_SETTYPE
  JE      .hlmSETTYPE
  CMP     EAX, HLM_SETUNDERLINE
  JE      .hlmSETUNDERLINE
  CMP     EAX, HLM_SETHOTCOLOR
  JE      .hlmSETHOTCOLOR
  CMP     EAX, HLM_SETTEXTCOLOR
  JE      .hlmSETTEXTCOLOR
  CMP     EAX, HLM_SETSUBJECT
  JE      .hlmSETSUBJECT
  CMP     EAX, HLM_SETLINK
  JE      .hlmSETLINK
  CMP     EAX, HLM_SETBODY
  JE      .hlmSETBODY
  CMP     EAX, WM_SETFONT
  JE      .wmSETFONT
  CMP     EAX, WM_LBUTTONDOWN
  JE      .wmLBUTTONDOWN
  CMP     EAX, WM_MOUSEMOVE
  JE      .wmMOUSEMOVE
  CMP     EAX, WM_MOUSELEAVE
  JE      .wmMOUSELEAVE
  CMP     EAX, WM_PAINT
  JE      .wmPAINT
  CMP     EAX, WM_DESTROY
  JE      .wmDESTROY
  JMP     DONE
  
  .wmSETTEXT:
    ; Obtenemos el tamao del borde de hlc_hWin
    invoke  GetWindowRect, [hlc_hWin], hlc_prc  ; Recupera las dimensiones del borde de una ventana
    mov     eax, [hlc_prc.right]
    sub     eax, [hlc_prc.left]
    push    eax                   ; Guardamos la anchura
    mov     eax, [hlc_prc.bottom]
    sub     eax, [hlc_prc.top]
    push    eax                   ; Guardamos la altitud
    invoke  GetClientRect, [hlc_hWin], hlc_prc   ; Recupera las CC del rea cliente de una ventana
    pop     eax     ; Recuperamos la altitud
    sub     eax, [hlc_prc.bottom]   ; A la altitud le restamos la CC lower-right de la ventana del rea cliente
    pop     ecx     ; Recuperamos la anchura
    push    eax     ; Guardamos la anchura
    sub     ecx, [hlc_prc.right]    ; Hacemos lo mismo con la anchura
    push    ecx  ; <- ECX= Tamao del borde de la anchura de hlc_hWin
    invoke  GetDC, [hlc_hWin]    ; Obtiene un handle para el DC de un rea cliente de una ventana
    mov     [hlc_hdc], eax
    invoke  GetWindowLong, [hlc_hWin], 20  ; Recupera informacin de una ventana especificada
    or      eax, eax       ; Fall=0?
    jnz     @F             ; No, saltamos
      invoke  GetStockObject, SYSTEM_FONT    ; Recupera un handle para uno de los pinceles(...) predefinidos
    @@:     
    invoke  SelectObject, [hlc_hdc], eax  ; Selecciona un objeto dentro de un DC
    invoke  lstrlen, [hlc_lParam]  ; Devuelve la longitud en bytes(ansi) o caracteres(Unicode) de una cadena
    mov     ecx, eax             ; Lo guarda en ECX
    invoke  DrawText, [hlc_hdc], [hlc_lParam], ecx, hlc_prc, DT_CALCRECT ; Formatea y dibuja un texto en un rectngulo
    pop     ecx    ; Recuperamos el tamao del borde de la anchura de hlc_hWin
    add     ecx, [hlc_prc.right]   ; Le sumamos la lower-right coordenada de la ventana
    sub     ecx, [hlc_prc.left]    ; Le restamos la upper-left coordenada de la ventana
    pop     eax
    add     eax, [hlc_prc.bottom]
    sub     eax, [hlc_prc.top]     ; En ECX tenemos la anchura de la ventana, en EAX la altura
    invoke  SetWindowPos, [hlc_hWin], HWND_TOP, 0, 0, ecx, eax, SWP_NOMOVE + SWP_NOZORDER ; Cambia el tamao, posicin, etc.
    invoke  ReleaseDC, [hlc_hWin], [hlc_hdc]   ; Libera un device context
    jmp     DONE
  .wmCREATE:
    invoke  GlobalAlloc, GPTR, 4192
    invoke  SetWindowLong, [hlc_hWin], 12, eax
    jmp     DONE
  .hlmSETTYPE:
    invoke  SetWindowLong, [hlc_hWin], 0, [hlc_lParam]
    ret
  .hlmSETUNDERLINE:
    invoke  SetWindowLong, [hlc_hWin], 32, [hlc_lParam]
    ret
  .hlmSETHOTCOLOR:
    invoke  SetWindowLong, [hlc_hWin], 4, [hlc_lParam]
    ; Set the current color if necessary
    invoke  GetCursorPos, hlc_pt
    invoke  GetParent, [hlc_hWin]
    push    eax
    mov     ecx, eax
    invoke  ScreenToClient, ecx, hlc_pt
    pop     ecx
    invoke  ChildWindowFromPoint, ecx, [hlc_pt.x], [hlc_pt.y]
    cmp     eax, [hlc_hWin]
    jne     @F
      invoke  SetWindowLong, [hlc_hWin], 16, [hlc_lParam]
      mov     [hlc_tme.cbSize], TRACKMOUSEEVENT_size
      mov     [hlc_tme.dwFlags], TME_LEAVE
      mov     eax, [hlc_hWin]
      mov     [hlc_tme.hwndTrack], eax
      mov     [hlc_tme.dwHoverTime], HOVER_DEFAULT
      invoke  _TrackMouseEvent, hlc_tme
    @@:
    invoke  InvalidateRect, [hlc_hWin], NULL, TRUE
    invoke  UpdateWindow, [hlc_hWin]
    ret
  .hlmSETTEXTCOLOR:
    invoke  SetWindowLong, [hlc_hWin], 8, [hlc_lParam]
    ; Set the current color if necessary
    invoke  GetCursorPos, hlc_pt
    invoke  GetParent, [hlc_hWin]
    push    eax
    mov     ecx, eax
    invoke  ScreenToClient, ecx, hlc_pt
    pop     ecx
    invoke  ChildWindowFromPoint, ecx, [hlc_pt.x], [hlc_pt.y]
    cmp     eax, [hlc_hWin]
    je      @F
      invoke  SetWindowLong, [hlc_hWin], 16, [hlc_lParam]
    @@:     
    invoke  InvalidateRect, [hlc_hWin], NULL, TRUE
    invoke  UpdateWindow, [hlc_hWin]
    ret
  .hlmSETSUBJECT:
    invoke  lstrlen, [hlc_lParam]
    inc     eax
    mov     [hlc_strlen], eax
    invoke  GetWindowLong, [hlc_hWin], 24
    mov     [hlc_pSubject], eax
    or      eax, eax
    jz      @F
      invoke  GlobalFree, eax
    @@:
    invoke  GlobalAlloc, GPTR, [hlc_strlen]
    mov     [hlc_pSubject], eax
    cmp     [hlc_strlen], 1024
    jl      @F
      mov     eax, [hlc_lParam]
      add     eax, 1023
      mov     byte [eax], 0
    @@:
    invoke  lstrcpy, [hlc_pSubject], [hlc_lParam]
    invoke  SetWindowLong, [hlc_hWin], 24, [hlc_pSubject]
    ret
  .hlmSETLINK:
    invoke  lstrlen, [hlc_lParam]
    inc     eax
    mov     [hlc_strlen], eax
    invoke  GetWindowLong, [hlc_hWin], 36
    mov     [hlc_pSubject], eax
    or      eax, eax
    jz      @F
      invoke  GlobalFree, eax
    @@:
    invoke  GlobalAlloc, GPTR, [hlc_strlen]
    mov     [hlc_pSubject], eax
    cmp     [hlc_strlen], 1024
    jl      @F
      mov     eax, [hlc_lParam]
      add     eax, 1023
      mov     byte [eax], 0
    @@:
    invoke  lstrcpy, [hlc_pSubject], [hlc_lParam]
    invoke  SetWindowLong, [hlc_hWin], 36, [hlc_pSubject]
    ret
  .hlmSETBODY:
    invoke  lstrlen, [hlc_lParam]
    inc     eax
    mov     [hlc_strlen], eax
    invoke  GetWindowLong, [hlc_hWin], 28
    mov     [hlc_pSubject], eax
    or      eax, eax
    jz      @F
      invoke  GlobalFree, eax
    @@:
    invoke  GlobalAlloc, GPTR, [hlc_strlen]
    mov     [hlc_pSubject], eax
    cmp     [hlc_strlen], 1024
    jl      @F
      mov     eax, [hlc_lParam]
      add     eax, 1023
      mov     byte [eax], 0
    @@:
    invoke  lstrcpy, [hlc_pSubject], [hlc_lParam]
    invoke  SetWindowLong, [hlc_hWin], 28, [hlc_pSubject]
    ret
  .wmSETFONT:
    ;   The def window proc does not do fonts so it has to be done manually
    invoke  SetWindowLong, [hlc_hWin], 20, [hlc_wParam]
    invoke  GetWindowText, [hlc_hWin], hlc_text, 256
    invoke  SetWindowText, [hlc_hWin], hlc_text
    mov     eax, [hlc_lParam]
    or      eax, eax
    jz      @F
      invoke  InvalidateRect, [hlc_hWin], NULL, TRUE
      invoke  UpdateWindow, [hlc_hWin]
    @@:
    ret
  .wmLBUTTONDOWN:
    invoke  GetWindowLong, [hlc_hWin], 12
    mov     [hlc_pSubject], eax
    invoke  GetWindowLong, [hlc_hWin], 0
    invoke  GetWindowLong, [hlc_hWin], 36
    mov     [hlc_pSubject], eax
    invoke  lstrlen, eax
    jnz     @F
      invoke  GetWindowText, [hlc_hWin], [hlc_pSubject], 256
    @@:
    stdcall FormatURL, [hlc_pSubject], hlc_text, TRUE
    invoke  ShellExecute, [hlc_hWin], hlc_szOpen, hlc_text, 0, 0, SW_SHOWNORMAL
    jmp     DONE
  .wmMOUSEMOVE:
    ;   The first mouse move message changes the color
    invoke  GetWindowLong, [hlc_hWin], 4
    push    eax
    invoke  SetWindowLong, [hlc_hWin], 16, eax
    pop     ecx
    cmp     eax, ecx
    je      DONE
    mov     [hlc_tme.cbSize], TRACKMOUSEEVENT_size
    mov     [hlc_tme.dwFlags], TME_LEAVE
    mov     eax, [hlc_hWin]
    mov     [hlc_tme.hwndTrack], eax
    mov     [hlc_tme.dwHoverTime], HOVER_DEFAULT
    invoke  _TrackMouseEvent, hlc_tme
    invoke  InvalidateRect, [hlc_hWin], NULL, TRUE
    jmp     DONE
  .wmMOUSELEAVE:
    invoke  GetWindowLong, [hlc_hWin], 8
    invoke  SetWindowLong, [hlc_hWin], 16, eax
    invoke  InvalidateRect, [hlc_hWin], NULL, TRUE
    ret
  .wmPAINT:
    invoke  GetWindowText, [hlc_hWin], hlc_text, 256
    mov     [hlc_strlen], eax
    invoke  GetWindowLong, [hlc_hWin], 16
    mov     [hlc_color], eax
    invoke  BeginPaint, [hlc_hWin], hlc_ps
    mov     [hlc_hdc], eax
    invoke  GetWindowLong, [hlc_hWin], 20
    invoke  SelectObject, [hlc_hdc], eax
    invoke  SetTextColor, [hlc_hdc], [hlc_color]
    invoke  GetSysColor, COLOR_3DFACE
    invoke  SetBkMode, [hlc_hdc], TRANSPARENT
    invoke  TextOut, [hlc_hdc], 0, 0, hlc_text, [hlc_strlen]
    invoke  GetWindowLong, [hlc_hWin], 32 ; Underline
    or      eax, eax
    jz      @F
      ; A line is drawn
      invoke  CreatePen, PS_SOLID, 1, [hlc_color]
      invoke  SelectObject, [hlc_hdc], eax
      push    eax
      invoke  GetClientRect, [hlc_hWin], hlc_prc
      dec     [hlc_prc.bottom]
      invoke  MoveToEx, [hlc_hdc], 0, [hlc_prc.bottom], NULL
      invoke  LineTo, [hlc_hdc], [hlc_prc.right], [hlc_prc.bottom]
      pop     eax
      invoke  SelectObject, [hlc_hdc], eax
      invoke  DeleteObject, eax
    @@:
    invoke  EndPaint, [hlc_hWin], hlc_ps
    ret
  .wmDESTROY:
    invoke  GetWindowLong, [hlc_hWin], 12
    or      eax, eax
    jz      @F
      invoke  GlobalFree, eax
    @@: 
    invoke  GetWindowLong, [hlc_hWin], 24
    or      eax, eax
    jz      @F
      invoke  GlobalFree, eax
    @@: 
    invoke  GetWindowLong, [hlc_hWin], 28
    or      eax, eax
    jz      @F
      invoke  GlobalFree, eax
    @@: 
    invoke  GetWindowLong, [hlc_hWin], 36
    or      eax, eax
    jz      DONE
    invoke  GlobalFree, eax
  DONE:
  invoke  DefWindowProc, [hlc_hWin], [hlc_uMsg], [hlc_wParam], [hlc_lParam]
  ret
endp

proc InitHyperLinkClass 
  ;  Propsito: Se inicializa la clase Hiperlink. El cdigo pertenece a Donkey Stable
  ;             (Edgar Hansen) ligeramente modificado por m
  ;  Entrada  : hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
  ;  Salida   : Ninguna
  ;  Destruye : Ninguna
;  LOCAL   hlc_wcx:WNDCLASSEX
  mov     [hlc_wcx.cbSize], WNDCLASSEX_size
  mov     [hlc_wcx.style], CS_HREDRAW + CS_VREDRAW
  invoke  GetModuleHandle, 0 ; <<<< So it doesn't assume the hInstance variable
  mov     [hlc_wcx.hInstance], eax
  mov     [hlc_wcx.lpszClassName], UDC_HyperClass    ; La clase que inicializamos
  mov     [hlc_wcx.cbClsExtra], 0
  mov     [hlc_wcx.cbWndExtra], 40
  mov     [hlc_wcx.lpfnWndProc], _Hyperlink          ; El gestor de la clase
  mov     [hlc_wcx.hIcon], NULL           ; No hay iconos
  mov     [hlc_wcx.hIconSm], NULL
  invoke  GetStockObject, NULL_BRUSH    ; Recoge el handle de una de las plumas(...) predefinidas
  mov     [hlc_wcx.hbrBackground], eax
  mov     [hlc_wcx.lpszMenuName], NULL
  invoke  LoadCursor, NULL, IDC_HAND    ; El cursor que se ver al pasar sobre el link ser una mano
  mov     [hlc_wcx.hCursor], eax
  invoke  RegisterClassEx, hlc_wcx
  ret
endp

proc FormatURL uses ebx esi edi, pString, pOutString, DoPercent
  ;  Propsito: Se copian los caracteres vlidos de la direccin web. El cdigo pertenece a 
  ;             Donkey Stable (Edgar Hansen) ligeramente modificado por m
  ;  Entrada  : hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
  ;  Salida   : Ninguna
  ;  Destruye : Ninguna
  mov     edi, [pOutString]
  mov     esi, [pString]
  mov     ebx, [DoPercent]
  Bucle:
    mov     al, byte [esi]
    cmp     al, 0
    je      Salir
    ; Caracteres "normales"
;    .if     al >= "a" && al <= "z" || al >= "A" && al <= "Z" || al >= "0" && al <= "9"
;      jmp     LoCopiamos
;    .endif
    ; ..., 0, 1, ..., 9, ..., A, B, ..., Z, ..., a, b, ..., z, ...
    CMP     AL, "0"              ; Todo lo que est por debajo del "0" no debe ser copiado
    JB      Salir2
    CMP     AL, "z"              ; Todo lo que est por encima de la "z" no debe ser copiado
    JA      Salir2
    CMP     AL, "9"
    JBE     LoCopiamos           ; Es un nmero, lo copiamos
    CMP     AL, "a"
    JAE     LoCopiamos           ; Es una letra minscula, la copiamos
    CMP     AL, "A"
    JB      @F                   ; Es un caracter especial entre el "9" y la "A"
    CMP     AL, "Z"              ; Es una letra mayscula, la copiamos
    JBE     LoCopiamos
    @@:
    ; Miramos entre los caracteres especiales cules deben ser copiados y cules no
    ; Reservado
    PUSH    EDI
    MOV     EDI, Reservado
    MOV     ECX, Reservado_size
    REPNE   SCASB                       ; Bucle de bsqueda
    POP     EDI
    JE      LoSaltamos                  ; Si se encontr
    ; Permitido
    PUSH    EDI
    MOV     EDI, Allowed
    MOV     ECX, Allowed_size
    REPNE   SCASB                       ; Bucle de bsqueda
    POP     EDI
    JE      LoCopiamos                  ; Si se encontr
    LoSaltamos:
      INC     ESI
      jmp     Bucle
    LoCopiamos:
      movsb
      jmp     Bucle
  Salir:
  mov     byte [edi], 0             ; Para hacerlo ASCIIZ
  Salir2:
  ret
endp

section '.data' data readable writeable
  Arial_Black_10  LOGFONT  -13,0,0,0,400,0,0,0,0,3,2,1,34,"Arial Black"
  WebSite         DB  "http://www.abreojosensamblador.net", 0   ; <- Aqu se pone la ruta real de la pgina web
  hlc_szBody      db  "&body=", 0
  hlc_szOpen      db  "open", 0
  hlc_const       db  "%%%0.2X", 0
  WebSiteDisplay  DB  "http://www.abreojosensamblador.net", 0  ; <- aqu se puede poner cualquier texto que enlazar con WebSite
  UDC_HyperClass  db  "UDC_HyperLink", 0
  Allowed         db  "()-_*.!/:"
  Allowed_size    =   $-Allowed
  Reservado       db  ";?@&=+$,%"
  Reservado_size  =   $-Reservado
  AboutText       DB  "1. Double image buttons", 13, 10
                  DB  "2. Custom cursor over a button", 13, 10
                  DB  "3. Modal and no modal messages", 13, 10
                  DB  "4. Changing objects properties on executing", 13, 10
                  DB  "5. Characterized message windows with icons", 13, 10
                  DB  "6. Buttons in group boxes and its usage", 13, 10
                  DB  "7. Hiperlink text", 13, 10
                  DB  "8. Creating objects matrix", 13, 10
                  DB  "9. ...", 13, 10
                  DB  "10. Always there is somebody arranged to say something to a politician :D", 0
  Credit          DB  "Hiperlink code based on Donkey Stable (Edgar Hansen)", 13,10
                  DB  "code with some little modifications :)",0
  hInstance       DD  ?
  hFont10         DD  ?
;  LOCAL hlc_tme:TRACKMOUSEEVENT, hlc_ps:PAINTSTRUCT, hlc_hdc:DWORD
;  LOCAL hlc_strlen:DWORD, hlc_prc:RECT, hlc_color:DWORD
;  LOCAL hlc_pt:POINT, hlc_text[2048]:BYTE, hlc_pSubject:DWORD
  hlc_tme         TRACKMOUSEEVENT
  hlc_ps          PAINTSTRUCT
  hlc_hdc         DD  ?
  hlc_strlen      DD  ?
  hlc_prc         RECT
  hlc_color       DD  ?
  hlc_pt          POINT
  hlc_text        RB 2048
  hlc_pSubject    rd  1
;  LOCAL   hlc_wcx:WNDCLASSEX
  hlc_wcx         WNDCLASSEX

  CommandLine      rd 1
  wHandle          rd 1
  hBmpUPolit       rd 1
  hBmpDPolit       rd 1
  hBmpJudge        rd 1
  hBmpPPolit       rd 1
  hIcoInfo         rd 1
  hIcoUExit        rd 1
  hIcoDExit        rd 1
  hCursor          rd 1
  hhWnd            rd 1
  NombreClase      TCHAR    'SimpleWinClass',0
  DlgName          TCHAR    'dlgInformation',0
  MsgCabecera      TCHAR    'Buttons example (FASM)',0
  MsgError         TCHAR    'Carga inicial fallida.',0
  wc               WNDCLASS 0,WndProc,0,0,NULL,NULL,NULL,cdColFondo,NULL,NombreClase
  mbp1             MSGBOXPARAMS
  msg              MSG
  MsgGpbBmp        db "bmp",0
  MsgGpbIco        db "ico",0
  MsgBtnPolit      db "Politician",0
  MsgBtnJudge      db "Judge",0
  MsgBtnInfo       db "Info",0
  MsgBtnExit       db "Exit",0
  MsgbtnTexto1     db "Message", 0
  MsgTxtPolit      db "Would you like to tell this politician anything?",0
  MsgTxtJudge1     db "This person can prohibit you to talk with the politician",0
  MsgTxtJudge2     db "This person can allow you talking with the politician",0
  MsgBmpJudgeCab   db "The judge dictaminates:", 0
  MsgBmpJudgeTxt1  db "You do not have permission to talk",13,10,"with the politician", 0
  MsgBmpJudgeTxt2  db "Now you can tell",13,10,"the politician which you want", 0
  MsgBmpPolitCab   db "The politician says:", 0
  MsgBmpPolitTxt   db "Aaaaayyyy!!", 0
  lpBtnProc        dd 0
  lpfnbmpProc      dd 0
  lpfnbmpProcBmp   dd 0
  lpBtnProcIco     dd 0
  ClaseBoton       db "BUTTON", 0
  ClaseTexto       db "STATIC", 0
  ClaseEdit        db "EDIT", 0
  vbButActiv       db 1 ; -1:true, 0:false (active/inactive), en principio est activado
  ; Aqu empieza la matriz de objetos a pintar en el formulario, 2 grupos
  ; El primer grupo tiene como padre la ventana del programa
  gpbBmp    DatosControl ClaseBoton, MsgGpbBmp,\
            WS_CHILD + WS_VISIBLE + BS_GROUPBOX, 5, 5, 235, 190, cdID_OBJETO,NULL
  gpbIco    DatosControl ClaseBoton, MsgGpbIco,\
            WS_CHILD + WS_VISIBLE + BS_GROUPBOX, 250, 95, 60, cdMAIN_ICON, cdID_OBJETO+1,NULL
  ; El segundo grupo (dividido en dos) tiene como padre al agrupador bmp
  ; Obsrvese que sus posiciones son relativas a las posiciones de sus agrupadores (contenedores)
  ; Aqui WS_TABSTOP no tiene efecto, se usa en el resource
   btnPolit DatosControl ClaseBoton, MsgBtnPolit,\
            WS_CHILD + WS_VISIBLE + BS_BITMAP + WS_TABSTOP, cdObjX1, cdObjY1, 80, 80, cdID_OBJETO+2,NULL
   btnJudge DatosControl ClaseBoton, MsgBtnJudge,\
            WS_CHILD + WS_VISIBLE + BS_BITMAP + WS_TABSTOP, cdObjX2, cdObjY2, 80, 80, cdID_OBJETO+3,NULL
   txtPolit DatosControl ClaseTexto, MsgTxtPolit,\
            WS_CHILD + WS_VISIBLE + DT_LEFT, cdObjX1+85, cdObjY1, 120, 60, cdID_OBJETO+4,NULL
   txtJudge DatosControl ClaseTexto, MsgTxtJudge1,\
            WS_CHILD + WS_VISIBLE + DT_RIGHT, cdObjX1, cdObjY2+25, 130, 60, cdID_OBJETO+5,NULL
  ; El tercer grupo tiene como padre al agrupador ico
  ; Obsrvese que sus posiciones son relativas a las posiciones de sus agrupadores (contenedores)
   btnInfo  DatosControl ClaseBoton, MsgBtnInfo,\
            WS_CHILD + WS_VISIBLE + BS_ICON + WS_TABSTOP, cdObjX3, cdObjY3, 36,36, cdID_OBJETO+6,NULL
   btnExit  DatosControl ClaseBoton, MsgBtnExit,\
            WS_CHILD + WS_VISIBLE + BS_ICON + WS_TABSTOP, cdObjX4, cdObjY4, 36,36, cdID_OBJETO+7,NULL
  ; Un boton sobre el hWnd
   btnMensaje  DatosControl ClaseBoton, MsgbtnTexto1,\
            WS_CHILD + WS_VISIBLE + BS_DEFPUSHBUTTON + WS_TABSTOP, 245, cdObjY1, 65, 30, cdID_OBJETO+8,NULL

section '.idata' import data readable writeable
  library kernel32,'KERNEL32.DLL',\    ; Importamos las bibliotecas para que el enlazador pueda trabajar
          user32,  'USER32.DLL',\
          gdi32,   'GDI32.DLL',\
          shell32, 'SHELL32.DLL',\
          comctl32,'COMCTL32.DLL'
          
  include 'api\kernel32.inc'           ; KERNEL32 API calls
  include 'api\user32.inc'             ; USER32 API calls
  include 'api\gdi32.inc'     
  include 'api\shell32.inc'     
  include 'api\comctl32.inc'     

    import    GDI32,\
              CreateFont,      'CreateFontA',\
              SelectObject,    'SelectObjectA',\
              DeleteObject,    'DeleteObjectA'

section '.rsrc' resource data readable

  ; resource directory

  directory RT_ICON,icons,\
            RT_GROUP_ICON,group_icons,\
            RT_BITMAP,appBmp,\
            RT_CURSOR,cursors,\
            RT_GROUP_CURSOR,group_cursors,\
            RT_VERSION,versions,\
            RT_DIALOG,dialogs

  ; resource subdirectories

  resource dialogs,\
     cdIdDialogo,LANG_SPANISH+SUBLANG_DEFAULT,dlgInformation

  resource icons,\
       1,LANG_NEUTRAL,icon_data,\
       2,LANG_NEUTRAL,icon_data2,\
       3,LANG_NEUTRAL,icon_data3,\
       4,LANG_NEUTRAL,icon_data4,\
       5,LANG_NEUTRAL,icon_data5,\
       6,LANG_NEUTRAL,icon_data6

  resource group_icons,\
       cdMAIN_ICON,LANG_NEUTRAL,main_icon,\
       cdWINDOW_ICON,LANG_NEUTRAL,window_icon,\
       cdINFO_ICON,LANG_NEUTRAL,info_icon,\
       cdEXIT_U_ICON,LANG_NEUTRAL,exit_u_icon,\
       cdEXIT_D_ICON,LANG_NEUTRAL,exit_d_icon,\
       cdJUDGE_ICON,LANG_NEUTRAL,judge_icon

  resource appBmp,\
       cdPOLIT_U_BMP,LANG_NEUTRAL,polit_u_bmp,\
       cdPOLIT_D_BMP,LANG_NEUTRAL,polit_d_bmp,\
       cdPOLIT_P_BMP,LANG_NEUTRAL,polit_p_bmp,\
       cdJUDGE_BMP,LANG_NEUTRAL,juzge_bmp

  resource cursors,\
       30,LANG_NEUTRAL,cursor_data

  resource group_cursors,\
       cdBOX_GLOBE_CUR,LANG_NEUTRAL,box_globe_cur

  resource versions,\
       1,LANG_NEUTRAL,version

  icon   main_icon,      icon_data,    '../../Res/BoxGlove.ico'
  icon   window_icon,    icon_data2,   '../../Res/a2.ico'
  icon   info_icon,      icon_data3,   '../../res/Info.ico'
  icon   exit_u_icon,    icon_data4,   '../../res/Exit0.ico'
  icon   exit_d_icon,    icon_data5,   '../../res/Exit.ico'
  icon   judge_icon,     icon_data6,   '../../res/Balanza2.ico'
  bitmap polit_u_bmp,                  '../../res/politician1.bmp'
  bitmap polit_d_bmp,                  '../../res/politician2.bmp'
  bitmap polit_p_bmp,                  '../../Res/politician3.bmp'
  bitmap juzge_bmp,                    '../../Res/Judge.bmp'
  cursor box_globe_cur,  cursor_data,  '../../Res/BoxGlove.cur'

  dialog dlgInformation,       'Information...',90,70,219,150,0x10CC0080
    dialogitem 'STATIC',       cdINFO_ICON,ID_STATIC,3,6,24,27,WS_VISIBLE+SS_ICON
    dialogitem 'STATIC',       'This program shows many things:',ID_STATIC,30,10,186,11,WS_VISIBLE
    dialogitem 'Edit',         '',cdIDC_EDT1,30,20,186,74,50210804h,00020000h
    dialogitem 'STATIC',       'Visit my website at',cdIDC_STC7,30,108,100,9,WS_VISIBLE
    dialogitem 'UDC_HyperLink','',cdIDC_UDC1,90,108,100,9,0x50000100
    dialogitem 'STATIC',       '(c) Abre ojos ensamblador. Alfonso Caballero',cdIDC_STC8,30,117,186,9,WS_VISIBLE
    dialogitem 'BUTTON',       'Accept',cdIDC_BUTTON,165,129,52,13,WS_VISIBLE+WS_TABSTOP+BS_DEFPUSHBUTTON
  enddialog

  versioninfo version,VOS__WINDOWS32,VFT_APP,VFT2_UNKNOWN,LANG_SPANISH+SUBLANG_DEFAULT,0,\
          'FileDescription',  'Buttons example',\
          'LegalCopyright',   'All rights reserved.',\
          'FileVersion',      '1.0.0.0',\
          'ProductVersion',   '1.0.0.0',\
          'CompanyName',      'Abre los ojos al ensamblador',\
          'OriginalFilename', 'butWF02.EXE'
 
